html {
  overflow-wrap: break-word;
  word-wrap: break-word;
  word-break: break-word;

  &.overlay-open .navbar-fixed-top {
    z-index: 400;
  }

  &.js {
    // Collapsible fieldsets.
    fieldset.collapsed {
      height: auto;
    }
    // Throbbers.
    input.form-autocomplete {
      background-image: none;
    }
  }
}

body {
  // Fix horizontal scrolling on iOS devices.
  // http://drupal.org/node/1870076
  // position: relative;
  font-weight: @font-weight-base;

  ul, ol {
    padding-left: 20px;
  }

  &.admin-expanded.admin-vertical.admin-nw .navbar,
  &.admin-expanded.admin-vertical.admin-sw .navbar {
    margin-left: 260px;
  }

  // Add padding to body if various toolbar or navbars are fixed on top.
  &.navbar-is-fixed-top {
    padding-top: 64px !important;
  }

  &.navbar-is-fixed-bottom {
    padding-bottom: 64px !important;
  }

  &.toolbar {
    padding-top: 30px !important;

    .navbar-fixed-top {
      top: 30px;
    }

    &.navbar-is-fixed-top {
      padding-top: 94px !important;
    }
  }

  &.toolbar-drawer {
    padding-top: 64px !important;

    .navbar-fixed-top {
      top: 64px;
    }

    &.navbar-is-fixed-top {
      padding-top: 128px !important;
    }
  }

  // Admin_menu toolbar.
  &.admin-menu {
    .navbar-fixed-top {
      top: 29px;
    }

    &.navbar-is-fixed-top {
      padding-top: 93px !important;
    }
  }

  div#admin-toolbar {
    z-index: 1600;
  }

  // Override box-shadow styles on all "admin" menus.
  #toolbar, #admin-menu, #admin-toolbar {
    .box-shadow(none);
  }

  // Override #admin-menu style.
  #admin-menu {
    margin: 0;
    padding: 0;
    position: fixed;
    z-index: 1600;

    .dropdown li {
      line-height: normal;
    }
  }
}

// Default navbar.
.navbar.container {
  margin-top: 20px;

  > .container {
    margin: 0;
    padding: 0;
    width: auto;
  }

  @media @tablet {
    max-width: ((@container-st  - 30px));
  }

  @media @very-smalld {
    max-width: ((@container-vsd - 30px));
  }

  @media @smalld {
    max-width: ((@container-sd  - 30px));
  }

  @media @middled {
    max-width: ((@container-md  - 30px));
  }

  @media @larged {
    max-width: ((@container-ld  - 30px));
  }
}

.container {
  @media @tablet {
    width: auto;
  }

  @media @very-smalld {
    width: ((@container-vsd - 100px));
  }

  @media @smalld {
    width: ((@container-sd - 100px));
  }
}

// Adjust z-index of core components.
#overlay-container,
.overlay-modal-background,
.overlay-element {
  z-index: 1500;
}

#toolbar {
  z-index: 1600;
}

// Adjust z-index of bootstrap modals
.modal {
  z-index: 1620;
}

.modal-dialog {
  z-index: 1630;
}

.modal-backdrop {
  z-index: 1610;
}

// Element invisible fix
.element-invisible {
  margin: 0;
  padding: 0;
  width: 1px;
}

// Navigation.
ul.secondary {
  float: left;

  @media @tablet {
    float: right;
  }
}

// Help region.
.region-help {
  > .glyphicon {
    font-size: @font-size-large;
    float: left;
    margin: -.05em .5em 0 0; // @todo Replace with proper variable
  }

  .block {
    overflow: hidden;
  }
}

// Search form.
form#search-block-form {
  margin: 0;
}

.navbar #block-search-form {
  float: none;
  margin: 5px 0 5px 5px; // @todo Replace with proper variable

  @media @very-smalld {
    float: right;
  }
}

.navbar-search .control-group {
  margin-bottom: 0;
}

// Form elements.
input, textarea, select, .uneditable-input {
  max-width: 100%;
  width: auto;
}

input.error {
  color: @state-danger-text;
  border-color: @state-danger-border;
}

fieldset legend.panel-heading {
  float: left;
  line-height: 1em;
  margin: 0;
}

fieldset .panel-body {
  clear: both;
}

fieldset .panel-heading a.panel-title {
  color: inherit;
  display: block;
  margin: -10px -15px;
  padding: 10px 15px;
  text-decoration: none;
}

.form-actions {
  clear: both;
  text-align: left;
}

.resizable-textarea textarea {
  border-radius: @border-radius-base @border-radius-base 0 0;
}

.radio, .checkbox {
  label {
    font-weight: @font-weight-base;
  }

  &:first-child {
    margin-top: 0;
  }

  &:last-child {
    margin-bottom: 0;
  }
}

.panel-heading {
  display: block;
}

a.tabledrag-handle .handle {
  height: auto;
  width: auto;
}

// Error containers.
.error {
  color: @state-danger-text;
}

div.error,
table tr.error {
  background-color: @state-danger-bg;
  color: @state-danger-text;
}

.control-group.error {
  background: none;

  label, .control-label {
    color: @state-danger-text;
  }

  input, textarea, select, .uneditable-input {
    color: @input-color;
    border: 1px solid @input-border;
  }

  .help-block, .help-inline {
    color: @text-color;
  }
}

// Lists
.list-inline {
  margin-left: 0;

  > li.first {
    padding-left: 0;
  }
}

ul li.collapsed,
ul li.expanded,
ul li.leaf {
  list-style: none;
  list-style-image: none;
}

// Submitted
.submitted {
  font-style: italic;
  font-weight: normal;
  color: #777;
}

// Password strength indicator.
.password-strength {
  width: 17em;
  float: right; /* LTR */
  margin-top: 1.4em;
}

.password-strength-title {
  display: inline;
}

.password-strength-text {
  float: right; /* LTR */
  font-weight: bold;
}

.password-indicator {
  background-color: @little-darker;
  height: 0.3em;
  width: 100%;

  div {
    height: 100%;
    width: 0;
    background-color: @brand-success;
  }
}

input.password-confirm,
input.password-field {
  width: 16em;
  margin-bottom: 0.4em;
}

div.password-confirm {
  float: right; /* LTR */
  margin-top: 1.5em;
  visibility: hidden;
  width: 17em;
}

div.form-item div.password-suggestions {
  padding: 0.2em 0.5em;
  margin: 0.7em 0;
  width: 38.5em;
  border: 1px solid #B4B4B4;
}

div.password-suggestions ul {
  margin-bottom: 0;
}

// Progress bar.
.progress-wrapper .progress {
  margin-bottom: 10px;
}

// Views AJAX pager.
.pagination ul > li > a {
  &.progress-disabled {
    float: left;
  }
}

/**
 * Missing Bootstrap 2 tab styling.
 * @see http://stackoverflow.com/questions/18432577/stacked-tabs-in-bootstrap-3
 * @see http://bootply.com/74926
 */
.tabbable {
  margin-top: @padding-large-horizontal; // @todo Replace with proper variable
}

.tabs-below, .tabs-left, .tabs-right {
  > .nav-tabs {
    border-bottom: 0;

    .summary {
      color: @nav-disabled-link-color;
      font-size: @font-size-small;
    }
  }
}

.tab-pane > .panel-heading {
  display: none;
}

.tab-content > .active {
  display: block;
}

// Below.
.tabs-below {
  > .nav-tabs {
    border-top: 1px solid @nav-tabs-border-color;

    > li {
      margin-top: -1px;
      margin-bottom: 0;

      > a {
        border-radius: 0 0 @border-radius-base @border-radius-base;

        &:hover,
        &:focus {
          border-top-color: @nav-tabs-border-color;
          border-bottom-color: transparent;
        }
      }
    }

    > .active {
      > a,
      > a:hover,
      > a:focus {
        border-color: transparent @nav-tabs-border-color @nav-tabs-border-color @nav-tabs-border-color;
      }
    }
  }
}

// Left and right tabs.
.tabs-left,
.tabs-right {
  > .nav-tabs {
    width: 220px;
    margin-bottom: 0;

    > li {
      float: none;

      &:focus {
        outline: 0;
      }

      > a {
        margin-right: 0;

        &:focus {
          outline: 0;
        }
      }
    }
  }

  > .tab-content {
    border-radius: 0 @border-radius-base @border-radius-base @border-radius-base;
    .box-shadow(0 1px 1px rgba(0, 0, 0, .05));
    border: 1px solid @nav-tabs-border-color;
    overflow: hidden;
    padding: @padding-large-vertical @padding-large-horizontal;
  }
}

// Left tabs.
.tabs-left {
  > .nav-tabs {
    float: left;
    margin-right: -1px;

    > li > a {
      border-radius: @border-radius-base 0 0 @border-radius-base;

      &:hover,
      &:focus {
        border-color: @nav-tabs-link-hover-border-color @nav-tabs-border-color @nav-tabs-link-hover-border-color @nav-tabs-link-hover-border-color;
      }
    }

    > .active {
      > a,
      > a:hover,
      > a:focus {
        border-color: @nav-tabs-border-color transparent @nav-tabs-border-color @nav-tabs-border-color;
        .box-shadow(-1px 1px 1px rgba(0, 0, 0, .05));
      }
    }
  }
}

// Right tabs.
.tabs-right {
  > .nav-tabs {
    float: right;
    margin-left: -1px;

    > li > a {
      border-radius: 0 @border-radius-base @border-radius-base 0;

      &:hover,
      &:focus {
        border-color: @nav-tabs-link-hover-border-color @nav-tabs-link-hover-border-color @nav-tabs-link-hover-border-color @nav-tabs-border-color;
        .box-shadow(1px 1px 1px rgba(0, 0, 0, .05));
      }
    }

    > .active > a,
    > .active > a:hover,
    > .active > a:focus {
      border-color: @nav-tabs-border-color @nav-tabs-border-color @nav-tabs-border-color transparent;
    }
  }
}

// Checkbox cell fix.
th.checkbox,
td.checkbox,
th.radio,
td.radio {
  display: table-cell;
}

// Views UI fixes.
.views-display-settings {
  .label {
    font-size: 100%;
    color: #666666;
  }

  .footer {
    padding: 0;
    margin: 4px 0 0 0;
  }
}

// Radio and checkbox in table fixes
table {
  td {
    &, &.radio, &.checkbox {
      position: static;
    }
  }

  .radio input[type="radio"],
  .checkbox input[type="checkbox"] {
    max-width: inherit;
  }
}

// Exposed filters
.form-horizontal .form-group label {
  position: relative;
  min-height: 1px;
  margin-top: 0;
  margin-bottom: 0;
  padding-top: 7px;
  padding-left: (@grid-gutter-width / 2);
  padding-right: (@grid-gutter-width / 2);
  text-align: right;

  @media (min-width: @screen-sm-min) {
    float: left;
    width: percentage((2 / @grid-columns));
  }
}

.to-right {
  float: right;
}

.ajax-progress {
  padding: 0 5px;
  margin: 0;
}

sup.beta {
  color: saturate(lighten(@brand-success, @tone*4), @tone);
  font-size: .6em;
  line-height: .3em;
  margin: 0;
}
